# Contributing the project

There are many ways on how to get involved in the project:

## Report bugs

If you stumble upon an issue, it would be time to describe it,
how it did actually happen (and describe possible steps to reproduce it) or even your hints on solving it.

## Suggest new features

If you have something on your mind, that is compatible with project's philosophy, let me know! I always appreciate any suggestions that can improve libraries' quality.

## Code

If you feel up for it, feel free to code and pull request any changes you've made, that can be useful for the libraries. This is the best way to help me out and it is highly appreciated!

## Code submission policy

Please follow the following rules when contributing to the project:
- Write in idiomatic ZPL C11 style
- Do not create external dependencies when introducing new features
- Split your changes to separate, atomic commits
- Rebase your commits on the master branch
- Wrap commit messages at 72 characters
- Format your commit message appropriately, the format should be: `Module: Brief commit description`, the `Module` can describe a file, structure or a process, depends on context
- Use proper English, with care for grammar and punctuation
- Commits should contain long description in case they are more complex, but they are not mandatory
- Squash your commits when creating revisions after a patch review takes place
